/**
* @file Paint.java
*
* @brief Diese Datei enthlt die abstrakte Klasse Paint.
*
* @author Philipp Bank, www.cypax.net\n
*
* @date 18.06.2006 - erste Version
*
**/

import java.awt.*;
import java.util.*;

/**
* @class Paint
* @brief Diese abstrakte Klasse stellt eine statische showArray()-Funktion zur Verfgung, um Integer-Arrays zu visualisieren.
*/
abstract class Paint
{

/**
* @brief Diese Funktion veranschaulicht Arraywerte durch grafische Ausgabe der Werte als vertikale, farbige Linien auf einem Panel.
* @param aArray - das Array mit Integerwerten
* @param aPanel - das Panel, auf dem gezeichnet werden soll
*/
  public static void showArray(int[] aArray, Panel aPanel)
  {
    Graphics g = aPanel.getGraphics();
    Color lc = new Color(0,255,0);       //grn
    Color bc = new Color(128,128,128);   //Hintergrundfarbe

    for (int i=0; i<210; i++)
    {
      g.setColor(lc);
      g.drawLine((i+20),190,(i+20),(190-aArray[i]));  //Zeichne eine vertikale grne Linie. Die Lnge der Linie in Pixeln entspricht dem Wert des Arrays an der Stelle i
      g.setColor(bc);
      g.drawLine((i+20),(190-aArray[i]),(i+20),10);  //zeichen eine vertikale Linie in Hintergrund-Farbe
    }

    aPanel.validate(); //zwinge das Panel dazu sich neu zu zeichnen
  }

}

