/**
* @file InsertionSort.java
*
* @brief Diese Datei enthlt die sorting.InsertionSort-Klasse.
*
* @author Philipp Bank, www.cypax.net\n
*
* @date 17.06.2006 - erste Version
*
**/

package sorting;

import java.awt.*;

/**
* @class InsertionSort
* @brief Die InsertionSort-Klasse erweitert die Sort-Klasse und sortiert Arrays mit dem Insertionsort-Algorithmus.
*
* Der verwendete Selectionsort-Code ist modifiziert von: <a href="http://de.wikipedia.org/wiki/Insertionsort">http://de.wikipedia.org/wiki/Insertionsort</a>.
*/
public class InsertionSort extends Sort
{

/**
* @brief Dies ist der Sortieralgorithmus.
*
* Der verwendete Selectionsort-Code ist modifiziert von: <a href="http://de.wikipedia.org/wiki/Insertionsort">http://de.wikipedia.org/wiki/Insertionsort</a>.
*/
  protected void doSort()
  {
    int pos;
    for (int i = 1; i <= theArray.length - 1; i++)
    {
      pos = binsearch(theArray, 0, i - 1, theArray[i]);
      move(i, pos, theArray);
      this.showArray();
      this.theLabel.setText(this.calcRuntime()+"ms");
      this.theLabel.validate();
    }
  }

  private void move(int i, int j, int[] a)
  {
    int tmp = a[i];
    for (int g = i; g >= j + 1; g--)
    {
      a[g] = a[g - 1];
    }
    a[j] = tmp;
  }

/**
* @brief Eine binre Suche
*
* Dies ist ein "binre Suche"-Algorithmus (<a href="http://de.wikipedia.org/wiki/Bin%C3%A4re_Suche">http://de.wikipedia.org/wiki/Bin%C3%A4re_Suche</a>)
* um einen gesuchten Wert in einem Array schnell zu finden.
*/
  private int binsearch(int[] a, int low, int high, int x)
  {
    int middle = 0;
    while (low <= high)
    {
      middle = (low + high) / 2;
      if (a[middle] == x) return middle;
      else if (a[middle] < x) low = middle + 1;
      else if (a[middle] > x) high = middle - 1;
    }
    return low;
  }

}
