/**
* @file SelectionSort.java
*
* @brief Diese Datei enthlt die sorting.SelectionSort-Klasse.
*
* @author Philipp Bank, www.cypax.net\n
*
* @date 17.06.2006 - erste Version
*
**/

package sorting;

import java.awt.*;

/**
* @class SelectionSort
* @brief Die SelectionSort-Klasse erweitert die Sort-Klasse und sortiert Arrays mit dem Selectionsort-Algorithmus.
*
* Der verwendete Selectionsort-Code ist modifiziert von: <a href="http://de.wikipedia.org/wiki/Selectionsort">http://de.wikipedia.org/wiki/Selectionsort</a>.
*/
public class SelectionSort extends Sort
{

/**
* @brief Dies ist der Sortieralgorithmus.
*
* Der verwendete Selectionsort-Code ist modifiziert von: <a href="http://de.wikipedia.org/wiki/Selectionsort">http://de.wikipedia.org/wiki/Selectionsort</a>.
*/
  protected void doSort()
  {
    for (int index=0; index<theArray.length-1; index++)
    {
      int minIdx = minimum(theArray, index, theArray.length-1);
      this.exchange(theArray, index, minIdx);
      this.showArray();
      this.theLabel.setText(this.calcRuntime()+"ms");
      this.theLabel.validate();
    }
  }

/**
* @brief Diese Funktion lokalisiert das Minimum in einem Teilarray.
*/
  private int minimum(int[] array, int anfang, int ende)
  {
    int minIdx = anfang;
    for (int index=anfang+1; index<=ende; index++)
    {
      if (array[index] < array[minIdx])
      {
        minIdx = index;
      }
    }
    return minIdx;
  }

}
